import { Container } from "../container.js";
import * as I from "../inspect.js";
import * as PP from "../pprint.js";
export class BlockInventory extends Container {
    #raw;
    static typeId = "minecraft:inventory";
    /// @internal
    constructor(raw) {
        if (raw.container)
            super(raw.container);
        else
            throw new Error(`This block does not have a valid container`);
        this.#raw = raw;
    }
    /// @internal
    [I.customInspectSymbol](inspect, stylise) {
        const obj = {
            container: new Container(this.#raw.container),
        };
        return PP.spaceCat(stylise(PP.text("BlockInventory"), I.TokenType.Class), inspect(obj));
    }
}
//# sourceMappingURL=inventory.js.map
