import { map } from "../../iterable.js";
import { Block } from "../../block.js";
import { Wrapper } from "../../wrapper.js";
import { Faced } from "../faced.js";
import { BlockPistonState } from "@minecraft/server";
import * as MC from "@minecraft/server";
export { BlockPistonState };
export class Piston extends Faced(Block) {
    #piston;
    /** Upcast a Block object representing `minecraft:piston`. */
    constructor(...args) {
        super(...args);
        this.#piston =
            this.getComponentOrThrow(MC.BlockPistonComponent.componentId);
    }
    get isMoving() {
        return this.#piston.isMoving;
    }
    get state() {
        return this.#piston.state;
    }
    get attachedBlocks() {
        return map(this.#piston.getAttachedBlocks(), (pos) => {
            return this.dimension.getBlock(pos);
        });
    }
}
export class PistonActivateAfterEvent extends Wrapper {
    isExpanding;
    piston;
    /// Package private
    constructor(rawEv) {
        super(rawEv);
        // Every field of MC.PistonActivateAfterEvent becomes undefined
        // after the event handler returns. We must copy them now.
        // THINKME: That sounds like a game bug. Is that still the case?
        this.isExpanding = rawEv.isExpanding;
        this.piston = new Piston(rawEv.piston.block);
    }
}
//# sourceMappingURL=piston.js.map
