import { map } from "../iterable.js";
import { Wrapper } from "../wrapper.js";
import * as I from "../inspect.js";
import * as PP from "../pprint.js";
import * as MC from "@minecraft/server";
export class BlockType extends Wrapper {
    /** Obtain all available block types registered within the world. */
    static getAll() {
        return map(MC.BlockTypes.getAll(), raw => {
            return new BlockType(raw);
        });
    }
    constructor(arg0) {
        if (arg0 instanceof MC.BlockType) {
            super(arg0);
        }
        else {
            const rawBt = MC.BlockTypes.get(arg0);
            if (rawBt)
                super(rawBt);
            else
                throw new Error(`No such block ID exists: ${arg0}`);
        }
    }
    get id() {
        return this.raw.id;
    }
    /// @internal
    [I.customInspectSymbol](inspect, stylise) {
        const obj = {
            id: this.id
        };
        return PP.spaceCat(stylise(PP.text("BlockType"), I.TokenType.Class), inspect(obj));
    }
}
//# sourceMappingURL=type.js.map
