import { Buffer } from "../buffer.js";
export class Builder {
    #ops;
    constructor() {
        this.#ops = [];
    }
    append(op) {
        this.#ops.push(op);
        return this;
    }
    toBuffer() {
        const buf = new Buffer();
        for (const op of this.#ops)
            op(buf);
        return buf;
    }
}
export const empty = _ => { };
export function putBuffer(buf) {
    return buf0 => buf0.append(buf);
}
export function putUint32(n, littleEndian) {
    return buf => buf.appendUint32(n, littleEndian);
}
//# sourceMappingURL=builder.js.map
