import { Buffer } from "../buffer.js";
export function length(seq) {
    if (typeof seq === "string" || Array.isArray(seq))
        return seq.length;
    else if (seq instanceof Uint8Array)
        return seq.byteLength;
    else if (seq instanceof Buffer)
        return seq.length;
    else
        throw new TypeError(`${seq} does not have length`);
}
export function subarray(seq, start, end) {
    if (typeof seq === "string" || Array.isArray(seq))
        return seq.slice(start, end);
    else if (seq instanceof Uint8Array)
        return seq.subarray(start, end);
    else if (seq instanceof Buffer)
        return seq.unsafeSubBuffer(start, end);
    else
        throw new TypeError(`${seq} is not sliceable`);
}
export function head(seq) {
    if (typeof seq === "string" || Array.isArray(seq) || seq instanceof Uint8Array) {
        return seq[0];
    }
    else if (seq instanceof Buffer) {
        for (const o of seq)
            return o;
        return undefined;
    }
    else {
        throw new TypeError(`${seq} isn't a sequence`);
    }
}
//# sourceMappingURL=sequence.js.map
