import { EntityComponent } from "./component.js";
import * as I from "../inspect.js";
import * as PP from "../pprint.js";
/// Base class for entity attribute components.
class EntityAttribute extends EntityComponent {
    get current() {
        return this.raw.currentValue;
    }
    set current(value) {
        this.raw.setCurrentValue(value);
    }
    get default() {
        return this.raw.defaultValue;
    }
    get max() {
        return this.raw.effectiveMax;
    }
    get min() {
        return this.raw.effectiveMin;
    }
    /// @internal
    [I.customInspectSymbol](inspect, stylise, _opts) {
        return PP.spaceCat(stylise(PP.text(this.constructor.name), I.TokenType.Class), PP.hsep([
            inspect(this.current),
            stylise(PP.brackets(PP.spaceCat(PP.text("default:"), PP.number(this.default))), I.TokenType.Tag),
            stylise(PP.brackets(PP.spaceCat(PP.text("min:"), PP.number(this.min))), I.TokenType.Tag),
            stylise(PP.brackets(PP.spaceCat(PP.text("max:"), PP.number(this.max))), I.TokenType.Tag)
        ]));
    }
}
export class EntityHealth extends EntityAttribute {
    static typeId = "minecraft:health";
}
export class EntityLavaMovement extends EntityAttribute {
    static typeId = "minecraft:lava_movement";
}
export class EntityMovement extends EntityAttribute {
    static typeId = "minecraft:movement";
}
export class EntityUnderwaterMovement extends EntityAttribute {
    static typeId = "minecraft:underwater_movement";
}
//# sourceMappingURL=attributes.js.map
