import { Container } from "../container.js";
import * as I from "../inspect.js";
import * as PP from "../pprint.js";
export class EntityInventory extends Container {
    #raw;
    static typeId = "minecraft:inventory";
    /// @internal
    constructor(raw) {
        if (raw.container)
            super(raw.container);
        else
            throw new Error(`This entity does not have a valid container`);
        this.#raw = raw;
    }
    get typeId() {
        return this.#raw.typeId;
    }
    get isValid() {
        return this.#raw.isValid;
    }
    get additionalSlotsPerStrength() {
        return this.#raw.additionalSlotsPerStrength;
    }
    get canBeSiphonedFrom() {
        return this.#raw.canBeSiphonedFrom;
    }
    get containerType() {
        return this.#raw.containerType;
    }
    get "private"() {
        return this.#raw.private;
    }
    get restrictToOwner() {
        return this.#raw.restrictToOwner;
    }
    /// @internal
    [I.customInspectSymbol](inspect, stylise) {
        const obj = {
            containerType: this.containerType,
            container: new Container(this.#raw.container),
        };
        if (this.additionalSlotsPerStrength > 0)
            obj.additionalSlotsPerStrength = this.additionalSlotsPerStrength;
        if (this.canBeSiphonedFrom)
            obj.canBeSiphonedFrom = true;
        if (this.private)
            obj.private = true;
        if (this.restrictToOwner)
            obj.restrictToOwner = true;
        return PP.spaceCat(stylise(PP.text("EntityInventory"), I.TokenType.Class), inspect(obj));
    }
}
//# sourceMappingURL=inventory.js.map
