/// See https://learn.microsoft.com/en-us/minecraft/creator/reference/content/rawmessagejson?view=minecraft-bedrock-experimental#formatting-codes-
export var Colour;
(function (Colour) {
    Colour["Black"] = "0";
    Colour["DarkBlue"] = "1";
    Colour["DarkGreen"] = "2";
    Colour["DarkAqua"] = "3";
    Colour["DarkRed"] = "4";
    Colour["DarkPurple"] = "5";
    Colour["Orange"] = "6";
    Colour["Gray"] = "7";
    Colour["DarkGray"] = "8";
    Colour["Blue"] = "9";
    Colour["Green"] = "a";
    Colour["LightBlue"] = "b";
    Colour["Red"] = "c";
    Colour["Pink"] = "d";
    Colour["Yellow"] = "e";
    Colour["White"] = "f";
    Colour["Gold"] = "g";
    Colour["WarmLightGray"] = "h";
    Colour["CoolLightGray"] = "i";
    Colour["DarkBrown"] = "j";
    Colour["DarkerRed"] = "m";
    Colour["Brown"] = "n";
    Colour["DarkGold"] = "p";
    Colour["Aqua"] = "s";
    Colour["DarkTeal"] = "t";
    Colour["Purple"] = "u";
})(Colour || (Colour = {}));
var FmtTag;
(function (FmtTag) {
    FmtTag[FmtTag["Reset"] = 0] = "Reset";
    FmtTag[FmtTag["SetColour"] = 1] = "SetColour";
    FmtTag[FmtTag["Obfuscate"] = 2] = "Obfuscate";
    FmtTag[FmtTag["Bold"] = 3] = "Bold";
    FmtTag[FmtTag["Italicise"] = 4] = "Italicise";
})(FmtTag || (FmtTag = {}));
export const reset = {
    tag: FmtTag.Reset
};
export function setColour(c) {
    return {
        tag: FmtTag.SetColour,
        colour: c
    };
}
export const obfuscate = {
    tag: FmtTag.Obfuscate
};
export const bold = {
    tag: FmtTag.Bold
};
export const italicise = {
    tag: FmtTag.Italicise
};
export function toString(codes) {
    return codes.map(c => {
        switch (c.tag) {
            case FmtTag.Reset: return "§r";
            case FmtTag.SetColour: return "§" + c.colour;
            case FmtTag.Obfuscate: return "§k";
            case FmtTag.Bold: return "§l";
            case FmtTag.Italicise: return "§o";
        }
    }).join("");
}
//# sourceMappingURL=fmt-code.js.map
