import { ItemComponent } from "./component.js";
import * as I from "../inspect.js";
import * as PP from "../pprint.js";
export class ItemCooldown extends ItemComponent {
    static typeId = "minecraft:cooldown";
    get category() {
        return this.raw.cooldownCategory;
    }
    get ticks() {
        return this.raw.cooldownTicks;
    }
    start(player) {
        this.raw.startCooldown(player.rawPlayer);
    }
    /// @internal
    [I.customInspectSymbol](inspect, stylise) {
        const obj = {
            category: this.category,
            ticks: this.ticks,
        };
        return PP.spaceCat(stylise(PP.text("ItemCooldown"), I.TokenType.Class), inspect(obj));
    }
}
//# sourceMappingURL=cooldown.js.map
