import { map } from "../iterable.js";
import { Wrapper } from "../wrapper.js";
import * as MC from "@minecraft/server";
export class ItemType extends Wrapper {
    constructor(arg0) {
        if (arg0 instanceof MC.ItemType) {
            super(arg0);
        }
        else {
            const rawIt = MC.ItemTypes.get(arg0);
            if (rawIt)
                super(rawIt);
            else
                throw new Error(`No such item ID exists: ${arg0}`);
        }
    }
    get id() {
        return this.raw.id;
    }
    /** Obtain all available item types registered within the world. */
    static getAll() {
        return map(MC.ItemTypes.getAll(), raw => {
            return new ItemType(raw);
        });
    }
}
//# sourceMappingURL=type.js.map
