import { Block } from "./block.js";
import { Entity } from "./entity.js";
import { Player } from "./player.js";
import { Wrapper } from "./wrapper.js";
export class ScriptEventCommandMessageAfterEvent extends Wrapper {
    /** Package private: user code should not use this. */
    constructor(rawEvent) {
        super(rawEvent);
    }
    get id() {
        return this.raw.id;
    }
    get initiator() {
        return this.raw.initiator
            ? (this.raw.initiator.typeId === "minecraft:player"
                ? new Player(this.raw.initiator)
                : new Entity(this.raw.initiator))
            : undefined;
    }
    get message() {
        return this.raw.message;
    }
    get sourceBlock() {
        return this.raw.sourceBlock
            ? new Block(this.raw.sourceBlock)
            : undefined;
    }
    get sourceEntity() {
        return this.raw.sourceEntity
            ? (this.raw.sourceEntity.typeId === "minecraft:player"
                ? new Player(this.raw.sourceEntity)
                : new Entity(this.raw.sourceEntity))
            : undefined;
    }
    get sourceType() {
        return this.raw.sourceType;
    }
}
//# sourceMappingURL=script-event.js.map
