/** Install a property to globalThis. Not intended for direct use. */
export function installGlobal(name, value, opts) {
    if (name in globalThis && !opts?.overwrite) {
        // It already exists.
    }
    else {
        if (!("cicada-lib" in globalThis)) {
            globalThis["cicada-lib"] = {};
        }
        if (!("shims" in globalThis["cicada-lib"])) {
            globalThis["cicada-lib"]["shims"] = new Set();
        }
        if (!globalThis["cicada-lib"]["shims"].has(name)) {
            // Even if opts.overwrite is enabled we don't want to overwrite
            // things we installed ourselves.
            Object.defineProperty(globalThis, name, {
                value,
                configurable: true,
                enumerable: false,
                writable: true
            });
            globalThis["cicada-lib"]["shims"].add(name);
        }
    }
}
//# sourceMappingURL=_util.js.map
