import { SystemAfterEvents, SystemBeforeEvents } from "./system/events.js";
import { Wrapper } from "./wrapper.js";
import * as MC from "@minecraft/server";
export class System extends Wrapper {
    /** System after-event signals */
    afterEvents;
    /** System before-event signals */
    beforeEvents;
    /** Package private: user code should not use this. */
    constructor(rawSystem) {
        super(rawSystem);
        this.afterEvents = new SystemAfterEvents(this.raw.afterEvents);
        this.beforeEvents = new SystemBeforeEvents(this.raw.beforeEvents);
    }
}
export const system = new System(MC.system);
//# sourceMappingURL=system.js.map
