import { GluedEventSignalWithoutOptions, GluedEventSignalWithOptions } from "../event.js";
import { ScriptEventCommandMessageAfterEvent } from "../script-event.js";
import { WatchdogTerminateBeforeEvent } from "../watchdog.js";
import { Wrapper } from "../wrapper.js";
import { identity } from "../function.js";
export class SystemAfterEvents extends Wrapper {
    scriptEventReceive;
    /** Package private: user code should not use this. */
    constructor(rawEvents) {
        super(rawEvents);
        this.scriptEventReceive = new GluedEventSignalWithOptions(this.raw.scriptEventReceive, (rawEv) => {
            return new ScriptEventCommandMessageAfterEvent(rawEv);
        }, identity);
    }
}
export class SystemBeforeEvents extends Wrapper {
    watchdogTerminate;
    /** Package private: user code should not use this. */
    constructor(rawEvents) {
        super(rawEvents);
        this.watchdogTerminate = new GluedEventSignalWithoutOptions(this.raw.watchdogTerminate, (rawEv) => {
            return new WatchdogTerminateBeforeEvent(rawEv);
        });
    }
}
//# sourceMappingURL=events.js.map
