export class Timer {
    #startedAt;
    constructor() {
        this.#startedAt = Date.now();
    }
    /// Return the elapsed time in milliseconds.
    get elapsedMs() {
        return Date.now() - this.#startedAt;
    }
    reset() {
        this.#startedAt = Date.now();
        return this;
    }
    toString() {
        let ms = this.elapsedMs;
        if (ms < 1000) {
            return `${ms}ms`;
        }
        else {
            const d = Math.floor(ms / 1000 / 60 / 60 / 24);
            ms %= 1000 * 60 * 60 * 24;
            const h = Math.floor(ms / 1000 / 60 / 60);
            ms %= 1000 * 60 * 60;
            const m = Math.floor(ms / 1000 / 60);
            ms %= 1000 * 60;
            const s = (ms / 1000).toFixed(3);
            return d > 0 ? `${d}d ${h}h ${m}m ${s}s`
                : h > 0 ? `${h}h ${m}m ${s}s`
                    : m > 0 ? `${m}m ${s}s`
                        : `${s}s`;
        }
    }
}
//# sourceMappingURL=timer.js.map
