import { ItemStack } from "../../../cicada-lib/dist/item/stack.js";
import { BlockProperties, blockProps } from "../../block-properties.js";
import { Fragile } from "../mixins.js";
// Bookshelf
blockProps.addBlockProps("minecraft:bookshelf", class extends Fragile(BlockProperties, new ItemStack("minecraft:book", 3)) {
    breakingSoundId() {
        return "dig.wood";
    }
    isToolSuitable(_perm, tool, prefs) {
        if (prefs.coverage.bookshelves)
            return tool.tags.has("minecraft:is_axe");
        else
            return false;
    }
});
// NOTE: We cannot allow Chiseled Bookshelf to be quick-mined because it
// doesn't have a block component minecraft:inventory for whatever reason
// and thus we cannot retrieve books inside it.
//# sourceMappingURL=bookshelves.js.map
