import { ItemStack } from "../../../cicada-lib/dist/item/stack.js";
import { BlockProperties, blockProps } from "../../block-properties.js";
import { MultiplicativeDrops, SilkTouchRequired } from "../mixins.js";
class CrystalProperties extends BlockProperties {
    isToolSuitable(_perm, tool, prefs) {
        if (prefs.coverage.crystals)
            return tool.tags.has("minecraft:is_pickaxe");
        else
            return false;
    }
}
// Amethyst buds
blockProps.addBlockProps("minecraft:small_amethyst_bud", class extends SilkTouchRequired(CrystalProperties) {
    breakingSoundId() {
        return "break.small_amethyst_bud";
    }
});
blockProps.addBlockProps("minecraft:medium_amethyst_bud", class extends SilkTouchRequired(CrystalProperties) {
    breakingSoundId() {
        return "break.medium_amethyst_bud";
    }
});
blockProps.addBlockProps("minecraft:large_amethyst_bud", class extends SilkTouchRequired(CrystalProperties) {
    breakingSoundId() {
        return "break.large_amethyst_bud";
    }
});
// Amethyst Cluster
blockProps.addBlockProps("minecraft:amethyst_cluster", class extends MultiplicativeDrops(CrystalProperties, new ItemStack("minecraft:amethyst_cluster"), 4, 4, new ItemStack("minecraft:amethyst_shard")) {
    breakingSoundId() {
        return "break.amethyst_cluster";
    }
});
//# sourceMappingURL=crystals.js.map
