import { ItemStack } from "../../../cicada-lib/dist/item/stack.js";
import { BlockProperties, blockProps } from "../../block-properties.js";
import { Drops, Fragile, IgnoringState } from "../mixins.js";
/// Base class for dirt-like rocks.
class DirtLikeProperties extends BlockProperties {
    isToolSuitable(_perm, tool, prefs) {
        if (prefs.coverage.dirtLike)
            return tool.tags.has("minecraft:is_shovel");
        else
            return false;
    }
    breakingSoundId() {
        return "dig.gravel";
    }
}
// Dirt
blockProps.addBlockProps("minecraft:dirt", DirtLikeProperties);
// Coarse Dirt
blockProps.addBlockProps("minecraft:coarse_dirt", DirtLikeProperties);
// Dirt Path
blockProps.addBlockProps("minecraft:grass_path", class extends Fragile(DirtLikeProperties, new ItemStack("minecraft:dirt")) {
    breakingSoundId() {
        return "dig.grass";
    }
});
// Farmland
blockProps.addBlockProps("minecraft:farmland", IgnoringState(Drops(DirtLikeProperties, new ItemStack("minecraft:dirt")), "moisturized_amount"));
// Grass Block
blockProps.addBlockProps("minecraft:grass_block", class extends Fragile(DirtLikeProperties, new ItemStack("minecraft:dirt")) {
    breakingSoundId() {
        return "dig.grass";
    }
});
// Mycelium
blockProps.addBlockProps("minecraft:mycelium", class extends Fragile(DirtLikeProperties, new ItemStack("minecraft:dirt")) {
    breakingSoundId() {
        return "dig.grass";
    }
});
// Podzol
blockProps.addBlockProps("minecraft:podzol", class extends Fragile(DirtLikeProperties, new ItemStack("minecraft:dirt")) {
});
// Rooted Dirt
blockProps.addBlockProps("minecraft:dirt_with_roots", DirtLikeProperties);
//# sourceMappingURL=dirt.js.map
