import { ItemStack } from "../../../cicada-lib/dist/item/stack.js";
import { BlockProperties, blockProps } from "../../block-properties.js";
import { Fragile } from "../mixins.js";
/// Base class for netherrack-like blocks.
class NetherrackLikeProperties extends BlockProperties {
    isToolSuitable(_perm, tool, prefs) {
        if (prefs.coverage.netherrackLike)
            return tool.tags.has("minecraft:is_pickaxe");
        else
            return false;
    }
}
// Netherrack
blockProps.addBlockProps("minecraft:netherrack", class extends NetherrackLikeProperties {
    breakingSoundId() {
        return "dig.netherrack";
    }
});
// Crimson Nylium
blockProps.addBlockProps("minecraft:crimson_nylium", class extends Fragile(NetherrackLikeProperties, new ItemStack("minecraft:netherrack")) {
    breakingSoundId() {
        return "dig.nylium";
    }
});
// Warped Nylium
blockProps.addBlockProps("minecraft:warped_nylium", class extends Fragile(NetherrackLikeProperties, new ItemStack("minecraft:netherrack")) {
    breakingSoundId() {
        return "dig.nylium";
    }
});
//# sourceMappingURL=netherrack.js.map
