import { BlockProperties, blockProps } from "../../block-properties.js";
import { DiamondTier } from "../mixins.js";
/// Base class for obsidian-like blocks.
class ObsidianLikeProperties extends BlockProperties {
    breakingSoundId() {
        return "dig.stone";
    }
    isToolSuitable(_perm, tool, prefs) {
        if (prefs.coverage.obsidian)
            return tool.tags.has("minecraft:is_pickaxe");
        else
            return false;
    }
}
// Crying obsidian
blockProps.addBlockProps("minecraft:crying_obsidian", DiamondTier(ObsidianLikeProperties));
// Obsidian
blockProps.addBlockProps("minecraft:obsidian", DiamondTier(ObsidianLikeProperties));
//# sourceMappingURL=obsidian.js.map
