import { ItemStack } from "../../../../cicada-lib/dist/item/stack.js";
import { BlockProperties, blockProps } from "../../../block-properties.js";
import { Fragile, IgnoringState } from "../../mixins.js";
/// Base class for abundant rocks.
class AbundantRockProperties extends BlockProperties {
    isToolSuitable(_perm, tool, prefs) {
        if (prefs.coverage.rocksAbundant)
            return tool.tags.has("minecraft:is_pickaxe");
        else
            return false;
    }
    breakingSoundId() {
        return "dig.stone";
    }
}
// Stone
blockProps.addBlockProps("minecraft:stone", Fragile(AbundantRockProperties, new ItemStack("minecraft:cobblestone")));
// Cobblestone
blockProps.addBlockProps("minecraft:cobblestone", AbundantRockProperties);
// Mossy Cobblestone
blockProps.addBlockProps("minecraft:mossy_cobblestone", AbundantRockProperties);
// Deepslate
blockProps.addBlockProps("minecraft:deepslate", class extends IgnoringState(Fragile(AbundantRockProperties, new ItemStack("minecraft:cobbled_deepslate")), "pillar_axis") {
    breakingSoundId() {
        return "dig.deepslate";
    }
});
// Cobbled Deepslate
blockProps.addBlockProps("minecraft:cobbled_deepslate", class extends AbundantRockProperties {
    breakingSoundId() {
        return "dig.deepslate";
    }
});
// End Stone
blockProps.addBlockProps("minecraft:end_stone", AbundantRockProperties);
//# sourceMappingURL=abundant.js.map
