import { BlockProperties, blockProps } from "../../../block-properties.js";
import { IgnoringState } from "../../mixins.js";
/// Base class for non-stone common rocks.
class CommonRockProperties extends BlockProperties {
    isToolSuitable(_perm, tool, prefs) {
        if (prefs.coverage.rocksCommon)
            return tool.tags.has("minecraft:is_pickaxe");
        else
            return false;
    }
}
// Andesite
blockProps.addBlockProps("minecraft:andesite", class extends CommonRockProperties {
    breakingSoundId() {
        return "dig.stone";
    }
});
// Basalt
blockProps.addBlockProps("minecraft:basalt", class extends IgnoringState(CommonRockProperties, "pillar_axis") {
    breakingSoundId() {
        return "dig.basalt";
    }
});
// Diorite
blockProps.addBlockProps("minecraft:diorite", class extends CommonRockProperties {
    breakingSoundId() {
        return "dig.stone";
    }
});
// Granite
blockProps.addBlockProps("minecraft:granite", class extends CommonRockProperties {
    breakingSoundId() {
        return "dig.stone";
    }
});
// Tuff
blockProps.addBlockProps("minecraft:tuff", class extends CommonRockProperties {
    breakingSoundId() {
        return "break.tuff";
    }
});
//# sourceMappingURL=common.js.map
