import { GameMode } from "../../../../cicada-lib/dist/player.js";
import { BlockProperties, blockProps } from "../../../block-properties.js";
/// Base class for uncommon stone rocks.
class UncommonRockProperties extends BlockProperties {
    isToolSuitable(_perm, tool, prefs) {
        if (prefs.coverage.rocksUncommon)
            return tool.tags.has("minecraft:is_pickaxe");
        else
            return false;
    }
}
// Blackstone
blockProps.addBlockProps("minecraft:blackstone", class extends UncommonRockProperties {
    breakingSoundId() {
        return "dig.stone";
    }
});
// Block of amethyst
blockProps.addBlockProps("minecraft:amethyst_block", class extends UncommonRockProperties {
    breakingSoundId() {
        return "break.amethyst_block";
    }
});
// Budding Amethyst
blockProps.addBlockProps("minecraft:budding_amethyst", class extends BlockProperties {
    breakingSoundId() {
        return "break.amethyst_block";
    }
    isProtected(_perm, player, prefs) {
        if (player.gameMode === GameMode.survival)
            return prefs.protection.keepBuddingAmethystFromBroken;
        else
            return false;
    }
    isToolSuitable() {
        // Never quick-mine them.
        return false;
    }
});
// Calcite
blockProps.addBlockProps("minecraft:calcite", class extends UncommonRockProperties {
    breakingSoundId() {
        return "break.calcite";
    }
});
// Dripstone block
blockProps.addBlockProps("minecraft:dripstone_block", class extends UncommonRockProperties {
    breakingSoundId() {
        return "break.dripstone_block";
    }
});
// Magma block
blockProps.addBlockProps("minecraft:magma", class extends UncommonRockProperties {
    breakingSoundId() {
        return "dig.stone";
    }
});
//# sourceMappingURL=uncommon.js.map
