var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _loots, _a;
import { ItemStack } from "../../../cicada-lib/dist/item/stack.js";
import { BlockProperties, blockProps } from "../../block-properties.js";
import { LootEntry, LootTable, LootPool } from "../../loot-table.js";
/// Base class for sand-like blocks.
class SandLikeProperties extends BlockProperties {
    isToolSuitable(_perm, tool, prefs) {
        if (prefs.coverage.sandLike)
            return tool.tags.has("minecraft:is_shovel");
        else
            return false;
    }
}
// Gravel
blockProps.addBlockProps("minecraft:gravel", (_a = class extends SandLikeProperties {
        constructor() {
            super(...arguments);
            _loots.set(this, new LootTable()
                .always([new LootPool().entry(LootEntry.gravelLike(new ItemStack("minecraft:gravel"), new ItemStack("minecraft:flint")))
            ]));
        }
        breakingSoundId() {
            return "dig.gravel";
        }
        lootTable() {
            return __classPrivateFieldGet(this, _loots, "f");
        }
    },
    _loots = new WeakMap(),
    _a));
// Sand
blockProps.addBlockProps("minecraft:sand", class extends SandLikeProperties {
    breakingSoundId() {
        return "dig.sand";
    }
});
// Red Sand
blockProps.addBlockProps("minecraft:red_sand", class extends SandLikeProperties {
    breakingSoundId() {
        return "dig.sand";
    }
});
//# sourceMappingURL=sand.js.map
