var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _MinerThread_instances, _a, _MinerThread_player, _MinerThread_playerPrefs, _MinerThread_tool, _MinerThread_dimension, _MinerThread_origLoc, _MinerThread_origPerm, _MinerThread_origProps, _MinerThread_scanned, _MinerThread_toScan, _MinerThread_toMine, _MinerThread_toMineFragile, _MinerThread_loots, _MinerThread_soundsPlayed, _MinerThread_experience, _MinerThread_isCreative_get, _MinerThread_horizDist, _MinerThread_vertDist, _MinerThread_scan, _MinerThread_playSound, _MinerThread_tryMining, _MinerThread_flushLoots, _b, _LocationSet_set, _LocationSet_loc2str, _LocationSet_str2loc;
import { OrdMap } from "../cicada-lib/dist/collections/ordered-map.js";
import { EquipmentSlot } from "../cicada-lib/dist/entity.js";
import { ItemBag } from "../cicada-lib/dist/item/bag.js";
import { Location } from "../cicada-lib/dist/location.js";
import { GameMode } from "../cicada-lib/dist/player.js";
import { Timer } from "../cicada-lib/dist/timer.js";
import { Thread } from "../cicada-lib/dist/thread.js";
import { MiningWay, blockProps } from "./block-properties.js";
import { isStandingOn } from "./utils.js";
import { worldPrefs } from "./world-prefs.js";
export class MinerThread extends Thread {
    constructor(player, tool, origin, perm) {
        super();
        _MinerThread_instances.add(this);
        _MinerThread_player.set(this, void 0);
        _MinerThread_playerPrefs.set(this, void 0);
        _MinerThread_tool.set(this, void 0);
        _MinerThread_dimension.set(this, void 0);
        _MinerThread_origLoc.set(this, void 0);
        _MinerThread_origPerm.set(this, void 0);
        _MinerThread_origProps.set(this, void 0);
        _MinerThread_scanned.set(this, void 0); // negative cache for scanning
        _MinerThread_toScan.set(this, void 0);
        _MinerThread_toMine.set(this, void 0);
        _MinerThread_toMineFragile.set(this, void 0);
        _MinerThread_loots.set(this, void 0);
        _MinerThread_soundsPlayed.set(this, void 0);
        _MinerThread_experience.set(this, void 0);
        __classPrivateFieldSet(this, _MinerThread_player, player, "f");
        __classPrivateFieldSet(this, _MinerThread_playerPrefs, player.getSession().playerPrefs, "f");
        __classPrivateFieldSet(this, _MinerThread_tool, tool, "f");
        __classPrivateFieldSet(this, _MinerThread_dimension, origin.dimension, "f");
        __classPrivateFieldSet(this, _MinerThread_origLoc, origin.location, "f");
        __classPrivateFieldSet(this, _MinerThread_origPerm, perm, "f");
        __classPrivateFieldSet(this, _MinerThread_origProps, blockProps.get(perm), "f");
        const ordBlock = (ba, bb) => {
            // We sort scheduled blocks by Y, then X, and then Z, and mine
            // blocks from the highest to the lowest. This is because
            // blocks might be gravity-affected and we don't want them to
            // fall.
            return ba.y > bb.y ? 1 :
                ba.y < bb.y ? -1 :
                    ba.x > bb.x ? 1 :
                        ba.x < bb.x ? -1 :
                            ba.z > bb.z ? 1 :
                                ba.z < bb.z ? -1 :
                                    0;
        };
        __classPrivateFieldSet(this, _MinerThread_scanned, new LocationSet(), "f");
        __classPrivateFieldSet(this, _MinerThread_toScan, new LocationSet(), "f");
        __classPrivateFieldSet(this, _MinerThread_toMine, new OrdMap(ordBlock), "f");
        __classPrivateFieldSet(this, _MinerThread_toMineFragile, new OrdMap(ordBlock), "f");
        __classPrivateFieldSet(this, _MinerThread_loots, new ItemBag(), "f");
        __classPrivateFieldSet(this, _MinerThread_soundsPlayed, new Set(), "f");
        __classPrivateFieldSet(this, _MinerThread_experience, 0, "f");
    }
    async *run() {
        const timer = new Timer();
        // The first path: discover blocks to quick-mine. This is a
        // non-destructive operation. Note that the block located at
        // this.#origLoc might not be the one we observed before spawning
        // this thread, which is fine because this.#scan() will not
        // schedule blocks incompatible with this.#origPerm.
        __classPrivateFieldGet(this, _MinerThread_instances, "m", _MinerThread_scan).call(this, __classPrivateFieldGet(this, _MinerThread_origLoc, "f"));
        while (__classPrivateFieldGet(this, _MinerThread_toScan, "f").size > 0) {
            const loc = __classPrivateFieldGet(this, _MinerThread_toScan, "f").deleteAny();
            __classPrivateFieldGet(this, _MinerThread_instances, "m", _MinerThread_scan).call(this, loc);
            if (timer.elapsedMs >= worldPrefs.timeBudgetInMsPerTick) {
                yield;
                timer.reset();
            }
        }
        // The second path: mine all blocks that we have decided to mine.
        try {
            // We must mine fragile blocks first.
            for (const toMine of [__classPrivateFieldGet(this, _MinerThread_toMineFragile, "f"), __classPrivateFieldGet(this, _MinerThread_toMine, "f")]) {
                for (const [block, [way, perm]] of toMine.entries().reverse()) {
                    if (__classPrivateFieldGet(this, _MinerThread_playerPrefs, "f").protection.keepGroundFromQuickMined) {
                        if (__classPrivateFieldGet(this, _MinerThread_player, "f").isValid && isStandingOn(__classPrivateFieldGet(this, _MinerThread_player, "f"), block))
                            continue;
                    }
                    if (!__classPrivateFieldGet(this, _MinerThread_instances, "m", _MinerThread_tryMining).call(this, block, way, perm))
                        break;
                    if (timer.elapsedMs >= worldPrefs.timeBudgetInMsPerTick) {
                        __classPrivateFieldGet(this, _MinerThread_instances, "m", _MinerThread_flushLoots).call(this);
                        __classPrivateFieldGet(this, _MinerThread_soundsPlayed, "f").clear();
                        yield;
                        timer.reset();
                    }
                }
            }
        }
        finally {
            __classPrivateFieldGet(this, _MinerThread_instances, "m", _MinerThread_flushLoots).call(this);
        }
    }
}
_a = MinerThread, _MinerThread_player = new WeakMap(), _MinerThread_playerPrefs = new WeakMap(), _MinerThread_tool = new WeakMap(), _MinerThread_dimension = new WeakMap(), _MinerThread_origLoc = new WeakMap(), _MinerThread_origPerm = new WeakMap(), _MinerThread_origProps = new WeakMap(), _MinerThread_scanned = new WeakMap(), _MinerThread_toScan = new WeakMap(), _MinerThread_toMine = new WeakMap(), _MinerThread_toMineFragile = new WeakMap(), _MinerThread_loots = new WeakMap(), _MinerThread_soundsPlayed = new WeakMap(), _MinerThread_experience = new WeakMap(), _MinerThread_instances = new WeakSet(), _MinerThread_isCreative_get = function _MinerThread_isCreative_get() {
    if (__classPrivateFieldGet(this, _MinerThread_player, "f").isValid)
        return __classPrivateFieldGet(this, _MinerThread_player, "f").gameMode == GameMode.creative;
    else
        return false;
}, _MinerThread_horizDist = function _MinerThread_horizDist(x, z) {
    return Math.sqrt(Math.pow(__classPrivateFieldGet(this, _MinerThread_origLoc, "f").x - x, 2) +
        Math.pow(__classPrivateFieldGet(this, _MinerThread_origLoc, "f").z - z, 2));
}, _MinerThread_vertDist = function _MinerThread_vertDist(y) {
    return Math.abs(__classPrivateFieldGet(this, _MinerThread_origLoc, "f").y - y);
}, _MinerThread_scan = function _MinerThread_scan(loc) {
    const block = __classPrivateFieldGet(this, _MinerThread_dimension, "f").getBlock(loc);
    if (!block) {
        // This block is either in an unloaded chunk or out of the world boundary,
        // so we can't do anything about it.
        __classPrivateFieldGet(this, _MinerThread_scanned, "f").add(loc);
        return false;
    }
    const way = __classPrivateFieldGet(this, _MinerThread_origProps, "f").miningWay(__classPrivateFieldGet(this, _MinerThread_origPerm, "f"), block.permutation, __classPrivateFieldGet(this, _MinerThread_playerPrefs, "f"));
    switch (way) {
        case MiningWay.LeaveAlone:
            __classPrivateFieldGet(this, _MinerThread_scanned, "f").add(loc);
            return false;
        case MiningWay.MineRegularly:
        case MiningWay.MineAsABonus:
            const perm = block.permutation;
            const props = blockProps.get(perm);
            if (props.isFragile(perm))
                __classPrivateFieldGet(this, _MinerThread_toMineFragile, "f").set(block, [way, perm]);
            else
                __classPrivateFieldGet(this, _MinerThread_toMine, "f").set(block, [way, perm]);
            __classPrivateFieldGet(this, _MinerThread_scanned, "f").add(loc);
            // This is one of the slowest part of this entire addon. We
            // must optimize this very carefully.
            for (let y = -1; y <= 1; y++) {
                if (__classPrivateFieldGet(this, _MinerThread_instances, "m", _MinerThread_vertDist).call(this, loc.y + y) > worldPrefs.maxVerticalDistance)
                    continue;
                for (let x = -1; x <= 1; x++) {
                    for (let z = -1; z <= 1; z++) {
                        const loc1 = loc.offset(x, y, z);
                        if (!__classPrivateFieldGet(this, _MinerThread_scanned, "f").has(loc1) && !__classPrivateFieldGet(this, _MinerThread_toScan, "f").has(loc1)) {
                            if (__classPrivateFieldGet(this, _MinerThread_instances, "m", _MinerThread_horizDist).call(this, loc.x + x, loc.z + z) > worldPrefs.maxHorizontalDistance)
                                __classPrivateFieldGet(this, _MinerThread_scanned, "f").add(loc1);
                            else
                                __classPrivateFieldGet(this, _MinerThread_toScan, "f").add(loc1);
                        }
                    }
                }
            }
            return true;
    }
}, _MinerThread_playSound = function _MinerThread_playSound(soundId, at) {
    if (__classPrivateFieldGet(this, _MinerThread_soundsPlayed, "f").has(soundId))
        return;
    if (at)
        __classPrivateFieldGet(this, _MinerThread_dimension, "f").playSound(soundId, at);
    else
        __classPrivateFieldGet(this, _MinerThread_player, "f").playSound(soundId);
    __classPrivateFieldGet(this, _MinerThread_soundsPlayed, "f").add(soundId);
}, _MinerThread_tryMining = function _MinerThread_tryMining(block, way, perm) {
    console.assert(way === MiningWay.MineRegularly ||
        way === MiningWay.MineAsABonus);
    // Things might have changed since we scanned blocks, as our
    // operation is asynchronous. Check if the block is still the one
    // we expect.
    const props = blockProps.get(perm);
    if (!props.isEquivalentTo(perm, block.permutation))
        return true;
    let toolWithstood = true;
    if (way === MiningWay.MineRegularly) {
        // Play a breaking sound only once per tick.
        __classPrivateFieldGet(this, _MinerThread_instances, "m", _MinerThread_playSound).call(this, props.breakingSoundId(perm), block.location);
        // Consume the durability unless the player is in creative.
        if (!__classPrivateFieldGet(this, _MinerThread_instances, "a", _MinerThread_isCreative_get) && props.consumesDurability(perm, __classPrivateFieldGet(this, _MinerThread_tool, "f"))) {
            // The item stack this.#tool is only a snapshot of the tool
            // the player used to initiate quick-mining. At this point
            // they might have put it in a chest, handed it to another
            // player, thrown it in lava, or whatever. So we have no
            // choice but to just reduce the durability of the tool the
            // player is currently holding in their main hand. Maybe we
            // can lock the tool in inventory but then we would take a
            // risk of permanently locking it in case of failure.
            if (!__classPrivateFieldGet(this, _MinerThread_player, "f").isValid)
                return false;
            const tool = __classPrivateFieldGet(this, _MinerThread_player, "f").equipment.get(EquipmentSlot.Mainhand);
            if (tool && tool.durability) {
                if (__classPrivateFieldGet(this, _MinerThread_playerPrefs, "f").protection.abortBeforeNamedToolBreaks) {
                    if (tool.nameTag !== undefined &&
                        tool.durability.current <= _a.TOOL_PROTECTION_MARGIN)
                        return false;
                }
                if (tool.durability.damage(1)) {
                    __classPrivateFieldGet(this, _MinerThread_dimension, "f").playSound("random.break", __classPrivateFieldGet(this, _MinerThread_player, "f").location);
                    // THINKME: This would be wrong for things like
                    // tools leaving scraps upon breaking, but there is
                    // currently no mechanism available for us to
                    // customise the behaviour.
                    __classPrivateFieldGet(this, _MinerThread_player, "f").equipment.delete(EquipmentSlot.Mainhand);
                    toolWithstood = false;
                }
                else {
                    __classPrivateFieldGet(this, _MinerThread_player, "f").equipment.set(EquipmentSlot.Mainhand, tool);
                }
            }
        }
    }
    // Tool enchantments should not apply to bonus mining.
    const tool = way === MiningWay.MineRegularly ? __classPrivateFieldGet(this, _MinerThread_tool, "f") : undefined;
    const loots = props.lootTable(perm).execute(tool);
    const xp = props.experience(perm, __classPrivateFieldGet(this, _MinerThread_tool, "f"));
    if (__classPrivateFieldGet(this, _MinerThread_playerPrefs, "f").loots.autoCollect) {
        __classPrivateFieldGet(this, _MinerThread_loots, "f").merge(loots);
        __classPrivateFieldSet(this, _MinerThread_experience, __classPrivateFieldGet(this, _MinerThread_experience, "f") + xp, "f");
    }
    else {
        // The player asked us to cause server lag by not automatically
        // collecting loots for them. Okay then. Spam the server with a
        // fabulous amount of item entities.
        if (!__classPrivateFieldGet(this, _MinerThread_instances, "a", _MinerThread_isCreative_get)) {
            for (const stack of loots)
                __classPrivateFieldGet(this, _MinerThread_dimension, "f").spawnItem(stack, block.location.offset(0.5));
            // We cannot spawn experience orbs with custom values. Shit.
            for (let i = 0; i < xp; i++)
                __classPrivateFieldGet(this, _MinerThread_dimension, "f").spawnEntity("minecraft:xp_orb", block.location.offset(0.5));
        }
    }
    props.break(block, tool);
    return toolWithstood;
}, _MinerThread_flushLoots = function _MinerThread_flushLoots() {
    var _c;
    // Place items directly in the player inventory.
    if (__classPrivateFieldGet(this, _MinerThread_player, "f").isValid) {
        // But creative players should not receive items or XPs.
        if (!__classPrivateFieldGet(this, _MinerThread_instances, "a", _MinerThread_isCreative_get)) {
            for (const stack of __classPrivateFieldGet(this, _MinerThread_loots, "f")) {
                const leftover = __classPrivateFieldGet(this, _MinerThread_player, "f").inventory.add(stack);
                if (leftover) {
                    // We should still play the "pop" sound if at least
                    // a part of the stack could be picked up.
                    if (leftover.amount < stack.amount)
                        __classPrivateFieldGet(this, _MinerThread_instances, "m", _MinerThread_playSound).call(this, "random.pop", __classPrivateFieldGet(this, _MinerThread_player, "f").location);
                    // Items that didn't fit in their inventory should
                    // be spawned as item entities.
                    __classPrivateFieldGet(this, _MinerThread_player, "f").dimension.spawnItem(leftover, __classPrivateFieldGet(this, _MinerThread_player, "f").location);
                }
                else {
                    __classPrivateFieldGet(this, _MinerThread_instances, "m", _MinerThread_playSound).call(this, "random.pop", __classPrivateFieldGet(this, _MinerThread_player, "f").location);
                }
            }
            if (__classPrivateFieldGet(this, _MinerThread_experience, "f") > 0) {
                // If the user has any equipped items that have Mending,
                // consume the XP for repairing them.
                const toMend = [];
                __classPrivateFieldGet(this, _MinerThread_player, "f").equipment.forEach((item, slot) => {
                    if (item.enchantments.has("mending")) {
                        const dur = item.durability;
                        if (dur && dur.current < dur.maximum)
                            toMend.push([slot, item]);
                    }
                });
                while (toMend.length > 0 && __classPrivateFieldGet(this, _MinerThread_experience, "f") > 0) {
                    const idx = Math.floor(Math.random() * toMend.length);
                    const [slot, item] = toMend[idx];
                    const dur = item.durability;
                    if (dur.maximum - dur.current >= 2) {
                        dur.current += 2;
                        __classPrivateFieldSet(this, _MinerThread_experience, (_c = __classPrivateFieldGet(this, _MinerThread_experience, "f"), _c--, _c), "f");
                    }
                    else {
                        // The tool has only 1 durability to repair. No
                        // XP is consumed in this case.
                        dur.current++;
                    }
                    __classPrivateFieldGet(this, _MinerThread_player, "f").equipment.set(slot, item);
                    if (dur.current >= dur.maximum)
                        // This tool is now fully repaired.
                        toMend.splice(idx, 1);
                }
            }
            // And if we still have XP to dispense, put it directly
            // into the player.
            while (__classPrivateFieldGet(this, _MinerThread_experience, "f") > 0) {
                const toNextLevel = __classPrivateFieldGet(this, _MinerThread_player, "f").totalXpNeededForNextLevel - __classPrivateFieldGet(this, _MinerThread_player, "f").xpEarnedAtCurrentLevel;
                const toAbsorb = Math.max(1, Math.min(__classPrivateFieldGet(this, _MinerThread_experience, "f"), toNextLevel));
                __classPrivateFieldGet(this, _MinerThread_player, "f").addExperience(toAbsorb);
                if (toAbsorb >= toNextLevel)
                    __classPrivateFieldGet(this, _MinerThread_instances, "m", _MinerThread_playSound).call(this, "random.levelup");
                else
                    __classPrivateFieldGet(this, _MinerThread_instances, "m", _MinerThread_playSound).call(this, "random.orb");
                __classPrivateFieldSet(this, _MinerThread_experience, __classPrivateFieldGet(this, _MinerThread_experience, "f") - toAbsorb, "f");
            }
        }
    }
    else {
        // But the player is invalid. Maybe the they have left?
        for (const stack of __classPrivateFieldGet(this, _MinerThread_loots, "f"))
            __classPrivateFieldGet(this, _MinerThread_dimension, "f").spawnItem(stack, __classPrivateFieldGet(this, _MinerThread_origLoc, "f").offset(0.5));
        // We cannot spawn experience orbs with custom values. Shit.
        for (let i = 0; i < __classPrivateFieldGet(this, _MinerThread_experience, "f"); i++)
            __classPrivateFieldGet(this, _MinerThread_dimension, "f").spawnEntity("minecraft:xp_orb", __classPrivateFieldGet(this, _MinerThread_origLoc, "f").offset(0.5));
    }
    __classPrivateFieldGet(this, _MinerThread_loots, "f").clear();
    __classPrivateFieldSet(this, _MinerThread_experience, 0, "f");
};
MinerThread.TOOL_PROTECTION_MARGIN = 4;
// My efforts on optimising HashSet didn't come to fruition. Initially it
// was 60x slower than this, and now it's still 2x slower than this abysmal
// abuse of the Set type although it's slightly faster than OrdSet. IT'S A
// SHAME.
class LocationSet {
    constructor() {
        _LocationSet_set.set(this, void 0);
        __classPrivateFieldSet(this, _LocationSet_set, new Set(), "f");
    }
    get size() {
        return __classPrivateFieldGet(this, _LocationSet_set, "f").size;
    }
    add(loc) {
        __classPrivateFieldGet(this, _LocationSet_set, "f").add(__classPrivateFieldGet(_b, _b, "m", _LocationSet_loc2str).call(_b, loc));
    }
    has(loc) {
        return __classPrivateFieldGet(this, _LocationSet_set, "f").has(__classPrivateFieldGet(_b, _b, "m", _LocationSet_loc2str).call(_b, loc));
    }
    deleteAny() {
        const str = __classPrivateFieldGet(this, _LocationSet_set, "f").values().next().value;
        if (str) {
            __classPrivateFieldGet(this, _LocationSet_set, "f").delete(str);
            return __classPrivateFieldGet(_b, _b, "m", _LocationSet_str2loc).call(_b, str);
        }
        else {
            return undefined;
        }
    }
}
_b = LocationSet, _LocationSet_set = new WeakMap(), _LocationSet_loc2str = function _LocationSet_loc2str(loc) {
    return `${loc.x},${loc.y},${loc.z}`;
}, _LocationSet_str2loc = function _LocationSet_str2loc(str) {
    const pos0 = str.indexOf(",");
    const pos1 = str.indexOf(",", pos0 + 1);
    return new Location(parseInt(str.substring(0, pos0)), parseInt(str.substring(pos0 + 1, pos1)), parseInt(str.substring(pos1 + 1)));
};
//# sourceMappingURL=miner-thread.js.map
