var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _PlayerSession_player, _PlayerSession_playerPrefs, _PlayerSession_playerPrefsUI, _PlayerSession_worldPrefsUI;
import { populateDefaults } from "./player-prefs.js";
import { PlayerPrefsUI } from "./player-prefs/ui.js";
import { WorldPrefsUI } from "./world-prefs/ui.js";
import * as PB from "./player-prefs_pb.js";
export class PlayerSession {
    constructor(player) {
        _PlayerSession_player.set(this, void 0);
        _PlayerSession_playerPrefs.set(this, void 0);
        _PlayerSession_playerPrefsUI.set(this, void 0);
        _PlayerSession_worldPrefsUI.set(this, void 0);
        this.runningMiner = null;
        __classPrivateFieldSet(this, _PlayerSession_player, player, "f");
        __classPrivateFieldSet(this, _PlayerSession_playerPrefs, populateDefaults(player.getPreferences(PB.PlayerPrefs)), "f");
        __classPrivateFieldSet(this, _PlayerSession_playerPrefsUI, null, "f");
        __classPrivateFieldSet(this, _PlayerSession_worldPrefsUI, null, "f");
    }
    get playerPrefs() {
        return __classPrivateFieldGet(this, _PlayerSession_playerPrefs, "f");
    }
    async openPlayerPrefsUI() {
        if (!__classPrivateFieldGet(this, _PlayerSession_playerPrefsUI, "f")) {
            try {
                __classPrivateFieldSet(this, _PlayerSession_playerPrefsUI, PlayerPrefsUI.open(__classPrivateFieldGet(this, _PlayerSession_player, "f"), __classPrivateFieldGet(this, _PlayerSession_playerPrefs, "f")), "f");
                await __classPrivateFieldGet(this, _PlayerSession_playerPrefsUI, "f");
            }
            finally {
                __classPrivateFieldSet(this, _PlayerSession_playerPrefsUI, null, "f");
            }
        }
    }
    async openWorldPrefsUI() {
        if (!__classPrivateFieldGet(this, _PlayerSession_worldPrefsUI, "f")) {
            try {
                __classPrivateFieldSet(this, _PlayerSession_worldPrefsUI, WorldPrefsUI.open(__classPrivateFieldGet(this, _PlayerSession_player, "f")), "f");
                await __classPrivateFieldGet(this, _PlayerSession_worldPrefsUI, "f");
            }
            finally {
                __classPrivateFieldSet(this, _PlayerSession_worldPrefsUI, null, "f");
            }
        }
    }
    destroy() {
        if (this.runningMiner) {
            this.runningMiner.cancel();
            // No need to join it. The thread takes care of leaving
            // players.
        }
    }
}
_PlayerSession_player = new WeakMap(), _PlayerSession_playerPrefs = new WeakMap(), _PlayerSession_playerPrefsUI = new WeakMap(), _PlayerSession_worldPrefsUI = new WeakMap();
//# sourceMappingURL=player-session.js.map
